<template>
  <video id="v1" autoplay loop muted>
    <source
      src="https://video.699pic.com/videos/55/06/24/a_vYJbXmjvQQbt1555550624.mp4"
      type="video/mp4"
    />
  </video>
  <div
    style="
      padding: 40px 60px;
      background-position: center;
      background-size: 100% auto;
      
    "
  >
    <div
      class="common-layout play-list-container"
      id="cont"
      style="border-radius: 80px; background-color: transparent;overflow: hidden;"
    >
      <div style="border-radius: 80px">
        <el-container style="background-color: transparent">
          <!-- 右列表 -->
          <el-aside width="260px" id="left-list">
            <div class="userList">
              <el-avatar
                :size="100"
                src="https://img2.baidu.com/it/u=3663542425,1908497549&fm=253&fmt=auto&app=120&f=JPEG?w=619&h=500"
              />
              <h1 style="color: white; font-size: 20px">{{ user.username }}</h1>
            </div>
            <el-menu>
              <el-menu-item index="2">
                <el-icon>
                  <Comment />
                </el-icon>
                <span @click="chat()">聊天</span>
              </el-menu-item>
              <el-menu-item index="2">
                <el-icon>
                  <User />
                </el-icon>
                <span @click="changingoverhs()">好友</span>
              </el-menu-item>
              <el-menu-item index="2">
                <el-icon>
                  <Promotion />
                </el-icon>
                <span @click="kongjian()">空间</span>
              </el-menu-item>
              <el-menu-item index="2">
                <el-icon>
                  <BellFilled />
                </el-icon>
                <span>推荐</span>
              </el-menu-item>
              <el-menu-item index="2">
                <el-icon>
                  <Place />
                </el-icon>
                <span>小游戏</span>
              </el-menu-item>
            </el-menu>
          </el-aside>
          <!-- 聊天界面 -->
          <el-main v-if="changingover == '聊天'" id="contt">
            <el-container style="border-radius;:20px;">
              <el-header class="head">
                <el-row style="height: 100%">
                  <el-col :span="4">
                    <div>
                      <h1>好友列表</h1>
                      <el-input
                        v-model="input"
                        placeholder="请输入好友名称"
                        style="width: 240px"
                      />
                    </div>
                  </el-col>
                  <el-col :span="6"></el-col>
                  <el-col
                    :span="10"
                    style="
                      height: 100%;
                      display: flex;
                      justify-content: center;
                      align-items: center;
                    "
                  >
                    <div style="text-align: center; font-size: 28px">
                      {{ fanusername }}
                    </div>
                  </el-col>
                </el-row>
              </el-header>
              <!-- 聊天界面 -->
              <el-container>
                <el-aside width="30%" class="head">
                  <div
                    v-for="(item, index) in firendList"
                    :key="index"
                    class="cell"
                  >
                    <div @click="SwitchFriends(item, index)">
                      <el-avatar
                        src="https://cube.elemecdn.com/0/88/03b0d39583f48206768a7534e55bcpng.png"
                      />
                      <span style="position: relative; left: 43px; top: -8px">{{
                        item.pyname
                      }}</span>
                    </div>
                  </div>
                </el-aside>
                <el-container>
                  <!-- 聊天内容 -->
                  <el-main
                    style="
                      background-color: rgb(0, 115, 255, 0.2);
                      border-top-left-radius: 10px;
                      border-top-right-radius: 10px;
                      height: 400px;
                    "
                  >
                    <div style="width: 100%; height: 100%; position: relative">
                      <tbody>
                        <tr v-for="(obj, index) in firendsorr" :key="index">
                          <td
                            style="margin-right: 20px"
                            v-if="obj.mycontent == null ? true : false"
                          >
                            <el-avatar
                              src="https://cube.elemecdn.com/0/88/03b0d39583f48206768a7534e55bcpng.png"
                            />
                          </td>
                          <td
                            v-if="obj.mycontent == null ? false : true"
                            style="margin-left: 20px; float: right"
                          >
                            <el-avatar
                              src="https://cube.elemecdn.com/0/88/03b0d39583f48206768a7534e55bcpng.png"
                            />
                          </td>
                          <td
                            style="
                              background: white;
                              padding: 10px;
                              border-radius: 5px;
                            "
                            :class="obj.mycontent == null ? '' : 'frcontents'"
                          >
                            {{ obj.frcontent || obj.mycontent }}
                          </td>
                        </tr>
                      </tbody>
                      <!-- 表情列表 -->
                      <div class="emojiss" v-show="isEmoShow">
                        <ul>
                          <li
                            v-for="(em, index) in emojis"
                            :key="index"
                            @click="apEmo(em)"
                          >
                            {{ em }}
                          </li>
                        </ul>
                      </div>
                    </div>
                  </el-main>
                  <el-footer
                    height="100px"
                    style="
                      background-color: rgb(247, 247, 247);
                      padding: 10px 0;
                    "
                  >
                    <div>
                      <el-row>
                        <el-col :span="2"></el-col>
                        <el-col :span="16">
                          <el-input v-model="form.desc" type="textarea" />
                        </el-col>
                        <!-- <el-col :span="1"></el-col> -->
                        <el-col
                          :span="4"
                          style="
                            display: flex;
                            justify-content: center;
                            align-items: center;
                          "
                        >
                          <el-button type="primary" circle @click="stEmolist">
                            11</el-button
                          >
                          <el-button type="primary" @click="onSubmit"
                            >发送</el-button
                          >
                        </el-col>
                      </el-row>
                      <!-- <el-form :model="form" label-width="120px">
                  <el-form-item label="" >
                    <el-input  v-model="form.desc" type="textarea" />
                  </el-form-item>
                  <el-form-item>
                    
                    
                  </el-form-item>
                </el-form> -->
                    </div>
                  </el-footer>
                </el-container>
              </el-container>
            </el-container>
          </el-main>

          <!-- 好友搜索界面 -->
          <el-main
            v-if="changingover == '好友'"
            id="contt"
            style="height: 580px; background-color: rgb(246, 246, 246, 0.6)"
          >
            <el-row style="height: 100%">
              <!-- 左边的好友搜索 -->
              <el-col :span="12">
                <el-row style="padding: 30px 0">
                  <el-col :span="5"></el-col>
                  <el-col :span="12">
                    <el-input
                      v-model="input1"
                      size="large"
                      placeholder="请输入需要搜索的好友"
                      :prefix-icon="Search"
                    />
                  </el-col>
                  <el-button
                    color="#3CA1A3"
                    :dark="isDark"
                    @click="Searchforfriends"
                    plain
                    style="height: 40px"
                    >搜索</el-button
                  >
                </el-row>
                <el-row
                  v-for="(value, index) in Searchinformationyes"
                  :key="index"
                >
                  <el-col :span="3"></el-col>
                  <el-col :span="18">
                    <!-- 搜索的好友名片 -->
                    <el-card style="width: 100%; padding: 0">
                      <div
                        style="
                          display: flex;
                          align-items: center;
                          flex-direction: row;
                        "
                      >
                        <el-avatar
                          :size="60"
                          src="http://localhost:8888/uimg/py.jpg"
                          style="margin-left: 10px"
                        />

                        <div
                          style="
                            padding-left: 10px;
                            font-size: 18px;
                            text-indent: 2px;
                          "
                        >
                          {{ value.username }}
                        </div>
                        <div style="padding-left: 120px">
                          <el-button
                            color="rgb(147, 255, 251)"
                            :dark="isDark"
                            @click="add(value)"
                            plain
                            >添加</el-button
                          >
                        </div>
                      </div>
                    </el-card>
                  </el-col>
                </el-row>
              </el-col>
              <!-- 右边的好友验证 -->
              <el-col :span="12" style="padding: 0 10px" id="fridenzz">
                <el-row
                  style="padding: 20px 0; border-bottom: #666666 2px solid"
                >
                  <el-col :span="2"></el-col>
                  <div
                    style="
                      font-size: 28px;
                      font-weight: 600;
                      color: rgb(10, 10, 10);
                    "
                  >
                    好友申请
                  </div>
                </el-row>
                <el-row>
                  <el-col :span="2"></el-col>
                  <el-col :span="20">
                    <el-card
                      v-for="(value, index) in FriendAddMessage"
                      :key="index"
                    >
                      <el-row>
                        <el-col :span="5">
                          <el-avatar
                            :size="60"
                            src="http://localhost:8888/uimg/user.jpg"
                            style="margin-left: 20px"
                          />
                        </el-col>
                        <el-col :span="11">
                          <div
                            style="
                              display: flex;
                              flex-direction: column;
                              justify-content: space-evenly;
                              height: 100%;
                              padding-left: 10px;
                            "
                          >
                            <div
                              style="
                                padding-left: 10px;
                                font-size: 18px;
                                text-indent: 2px;
                              "
                            >
                              {{ value.username }}
                            </div>
                            <p style="padding-left: 10px; font-size: 10px">
                              3月29日 12:12
                            </p>
                          </div>
                        </el-col>
                        <el-col :span="8">
                          <div
                            style="
                              display: flex;
                              align-items: center;
                              justify-content: center;
                              height: 100%;
                            "
                          >
                            <el-button
                              color="#626aef"
                              :dark="isDark"
                              plain
                              @click="agree(value)"
                              >同意</el-button
                            >
                            <el-button color="pink" :dark="isDark" plain
                              >拒绝</el-button
                            >
                          </div>
                        </el-col>
                      </el-row>
                    </el-card>
                  </el-col>
                </el-row>
              </el-col>
            </el-row>
          </el-main>
          <!-- 空间 -->
          <el-main
            v-if="changingover == '空间'"
            style="height: 580px; color: white"
            id="kongjiana"
          >
            <el-row style="height: 100%">
              <el-row
                style="
                  height: 12%;
                  width: 100%;
                  margin-bottom: 0;
                  padding-left: 20px;
                  border-bottom: 2px #999999 solid;
                  display: flex;
                  align-items: center;
                "
              >
                <div style="font-size: 30px; color: white">我的动态</div>
              </el-row>
              <el-row style="height: 88%; width: 100%">
                <!--  -->
                <el-col :span="18" style="padding-top: 20px; height: 100%">
                  <div class="myposts" style="padding: 20px" v-for="(post1, index) in postList" :key="index">
                    <!-- 帖子列表 -->
                    <el-row style="margin-bottom: 10px;width: 100%;" >
                      <el-col :span="3">
                        <el-avatar
                          :size="50"
                          src="https://img2.baidu.com/it/u=3663542425,1908497549&fm=253&fmt=auto&app=120&f=JPEG?w=619&h=500"
                        />
                      </el-col>
                      <el-col :span="8">
                        <div>
                          <p>{{ user.username }}</p>
                          <p>{{ new Date(post1.creatTime).toLocaleString() }}</p>
                        </div>
                      </el-col>
                    </el-row>
                    <el-row>
                      <div>
                        {{ post1.content }}
                      </div>
                    </el-row>
                    <el-row id="imgList" style="width: 100%;">
                      <e-col :span="12"  v-for="(imgs, index) in this.urlList[index]" :key="index">
                      <img v-if="post1.type = 'img'" :src="'http://localhost:8888'+imgs" alt="">
                      <video src="" v-if="post1.type = 'video'"></video>
                      </e-col>
                    </el-row>
                    <el-row>
                      <el-col :span="4">
                        <el-icon v-if="!userList.isLike" @click="UpLike(index)">
                          <Star />
                        </el-icon>
                        <el-icon v-else @click="UpLike(index)">
                          <StarFilled /> </el-icon
                        >
                        点赞 {{ post1.like }}
                      </el-col>
                      <el-col :span="4">
                        <el-icon>
                          <ChatDotSquare /> </el-icon
                        >
                        评论 {{ post1.collect }}
                      </el-col>
                      <el-col :span="4">
                        <el-icon
                          v-if="!userList.isCollect"
                          @click="UpCollect(index)"
                        >
                          <Star />
                        </el-icon>
                        <el-icon v-else @click="UpCollect(index)">
                          <StarFilled />
                        </el-icon>
                        收藏 {{ post1.comment }}
                      </el-col>
                    </el-row>
                  </div>
                </el-col>
                <el-col
                  :span="6"
                  style="
                    border: 1px #999999 solid;
                    padding-top: 20px;
                    color: white;
                  "
                >
                  <el-row> <div style="font-size: 20px">推荐好友</div> </el-row>
                  <el-row
                    style="padding: 5px 20px; margin: 10px; height: 45px"
                    class="tjlist"
                  >
                    <el-avatar :size="35" :src="userPic" />
                    <div style="padding-left: 10px; line-height: 35px">
                      夏一乘
                    </div>
                  </el-row>
                </el-col>
              </el-row>
            </el-row>
          </el-main>
          <!-- 小游戏 -->
          <el-main v-if="changingover == '游戏'">

          </el-main>
        </el-container>
      </div>
    </div>
  </div>
</template>
<script>
import { Search } from "@element-plus/icons-vue";
import { reactive } from "vue";
import { ref } from "vue";
import { getCurrentInstance } from "vue";
import { HttpManager } from "@/api";
import "@/assets/icons/index.js";
import axios from "axios";
import { ElMessageBox } from "element-plus";
import {
  Star,
  StarFilled,
  ChatDotSquare,
  Message,
  Comment,
  User,
  Promotion,
  BellFilled,
  Place,
  circleUrl,
} from "@element-plus/icons-vue";
export default {
  data() {
    return {
      //
      postList: '',
      myPost: [],
      urlList: [],
      user: getCurrentInstance().proxy.$store.state.user,
      emojis: [
        "😀",
        "😄",
        "😅",
        "🤣",
        "😂",
        "😉",
        "😊",
        "😍",
        "😘",
        "😜",
        "😝",
        "😏",
        "😒",
        "🙄",
        "😔",
        "😴",
        "😷",
        "🤮",
        "🥵",
        "😎",
        "😮",
        "😰",
        "😭",
        "😱",
        "😩",
        "😡",
        "💀",
        "👽",
        "🤓",
        "🥳",
        "😺",
        "😹",
        "😻",
        "🤚",
        "💩",
        "👍",
        "👎",
        "👏",
        "🙏",
        "💪",
      ],
      userList: {
        isLike: true,
        isCollect: true,
      },
      // post:{
      //   like:12,
      //   collect:12,
      //   comment:12,
      // },
      // 表情显示开关
      isEmoShow: false,
    };
  },
  created() {
    console.log(this.user);
    this.getPost();
  },
  methods: {
    getPost(){
    let left = this
    // 获取帖子列表
    axios({
      method: "GET",
      url: " http://localhost:8888/dynamic/byid?uid=" + 649,
    }).then((res) => {
      console.log(res.data);
      left.postList = res.data
      // 过滤地址
      for (let i = 0; i < res.data.length; i++) {
        this.urlList.push(res.data[i].contentUrl.split("!!"));
        // this.postList.push(res.data[i])
        if (res.data[i].uid == this.user.userId) {
          left.myPost.push(res.data[i]);
        }
      }
    console.log("qqq");
    console.log(this.urlList);
    console.log(left.postList);
    console.log(left.myPost);
    });
    },
    stEmolist() {
      this.isEmoShow = !this.isEmoShow;
    },
    apEmo(emoji) {
      this.form.desc = this.form.desc + emoji;
    },
  },
  components: {
    StarFilled,
    Star,
    ChatDotSquare,
    Comment,
    User,
    Promotion,
    BellFilled,
    Place,
  },
  setup(props) {
    const form = reactive({
      desc: "",
    });
    // 切换对象
    const changingover = ref("聊天");
    // 搜索内容
    const SearchContent = ref([]);

    const { proxy } = getCurrentInstance();
    //上方的显示
    const fanusername = ref();
    // 好友列表数据
    const firendList = ref([]);
    // 用来装总信息的
    const firendsorr = ref([]);
    // 搜索框里面的值
    const input1 = ref("");
    //搜索到的好友信息
    const Searchinformationyes = ref();
    //好友添加消息的出现
    const FriendAddMessage = ref([]);

    const userId = ref(proxy.$store.state.user.userId);

    const pyidyes = ref();
    //用来装好友列表的
    async function getfirendsall() {
      console.log(userId.value);
      firendList.value = await HttpManager.getfiendsall(userId.value);
      // console.log(firendList.value);
    }
    getfirendsall();
    //点击切换好友的函数
    function SwitchFriends(item) {
      fanusername.value = item.pyname;
      pyidyes.value = item.prid;
      //获取好友聊天内容
      async function getfirendsconst() {
        firendsorr.value = await HttpManager.getCatserve(
          userId.value,
          pyidyes.value
        );
      }
      getfirendsconst();
      setInterval(function () {
        getfirendsconst();
      }, 5000);
    }
    // 好友搜索界面

    function changingoverhs() {
      changingover.value = "好友";
    }
    function chat() {
      changingover.value = "聊天";
    }
    function kongjian() {
      changingover.value = "空间";
    }
    const onSubmit = () => {
      HttpManager.getSendachatmessage(userId.value, pyidyes.value, form.desc);
      async function getfirendsconst() {
        firendsorr.value = await HttpManager.getCatserve(
          userId.value,
          +pyidyes.value
        );
        console.log(firendsorr.value);
        form.desc = "";
      }
      getfirendsconst();
    };
    // =========================好友界面的列表
    async function Searchforfriends() {
      const rest = await HttpManager.getUserOfId(input1.value);
      Searchinformationyes.value = rest.data;
      console.log(Searchinformationyes.value);
    }
    async function add(value) {
      await HttpManager.AddFriends(userId.value, value.id);

      console.log("yes");
    }
    // 好友消息显示
    async function Message() {
      let yes = await HttpManager.HaoYouXiaoXi(userId.value);
      // FriendAddMessage.value = redst
      console.log("yess", yes);
      console.log(yes[0].pyid);
      let good;
      good = await HttpManager.getUserOfId(yes[0].pyid);
      FriendAddMessage.value = good.data;
      console.log(FriendAddMessage.value);
    }
    async function agree(value) {
      location.reload();
      let type = 2;
      await HttpManager.Confirmconsen(userId.value, value.id, type);
      console.log("yes");
    }
    Message();
    return {
      kongjian,
      SwitchFriends,
      firendList,
      fanusername,
      firendsorr,
      onSubmit,
      form,
      changingover,
      changingoverhs,
      chat,
      SearchContent,
      input1,
      Search,
      Message,
      Comment,
      User,
      Promotion,
      BellFilled,
      Place,
      ElMessageBox,
      circleUrl,
      Searchforfriends,
      Searchinformationyes,
      add,
      FriendAddMessage,
      agree,
    };
  },
};
</script>
<style scoped>
body {
  overflow: hidden;
}
</style>
<style >
.el-card__body {
  padding: 10px;
}

.el-main {
  --el-main-padding: 0;
  background-color: transparent;
}
</style>
<style scoped>
#contt {
  border-top-right-radius: 40px;
  border-bottom-right-radius: 40px;
  /* border-bottom-left-radius:8% ; */
  background-color: rgba(211, 211, 211, 0.3);
}
.myposts:hover {
  background-color: rgb(255, 255, 255, 0.1);
}
#kongjiana {
  gap: 20px;
  border-radius: 3px;
  backdrop-filter: blur(0px);
  background-color: rgba(235, 255, 255, 0.178);
  box-shadow: rgba(0, 0, 0, 0.3) 2px 8px 8px;
  border: 1px rgba(255, 255, 255, 0.4) solid;
  border-bottom: 1px rgba(40, 40, 40, 0.35) solid;
  border-right: 1px rgba(40, 40, 40, 0.35) solid;
}
.tjlist:hover {
  background-color: rgba(205, 255, 254, 0.2);
}
#contt section {
}

#cont {
  /* box-shadow:#999999 10px 10px 10px; */
}

#cont > div {
  /* background: linear-gradient(
    rgb(73, 183, 157) 0%,
    rgb(73, 180, 194) 100%
  ); */
}
#imgList img{
  height: 100px;
  padding-right: 10px;
}
#left-list {
  border-top-left-radius: 40px;
  border-bottom-left-radius: 40px;
  /* color: white; */
  backdrop-filter: blur(4px);
  background-color: rgba(0, 191, 255, 0.043);
  box-shadow: rgba(0, 0, 0, 0.3) 2px 8px 8px;
  border: 2px rgba(255, 255, 255, 0.4) solid;
  border-bottom: 2px rgba(40, 40, 40, 0.35) solid;
  border-right: 2px rgba(40, 40, 40, 0.35) solid;
}
video {
  position: fixed;
  right: 0px;
  bottom: 0px;
  min-width: 100%;
  min-height: 100%;
  height: auto;
  width: auto;
  /*加滤镜*/
  /*filter: blur(15px); //背景模糊设置 */
  /*-webkit-filter: grayscale(100%);*/
  /*filter:grayscale(100%); //背景灰度设置*/
  z-index: -11;
}

source {
  min-width: 100%;
  min-height: 100%;
  height: auto;
  width: auto;
}
#left-list .userList {
  padding-top: 10px;
  height: 160px;
  width: 100%;
  display: flex;
  flex-direction: column;
  justify-content: space-around;
  align-items: center;
}

#left-list > .el-menu {
  margin-top: 20px;
  padding: 10px;
  background-color: transparent;
  width: 100%;
}

#left-list > .el-menu > .el-menu-item {
  font-size: 16px;
  color: white;
  margin: 10px;
}

#left-list > .el-menu > .el-menu-item:hover {
  background-color: rgb(255, 255, 255, 0.1);
}

#contt {
  /* border-radius: 20px; */
}

tbody {
  display: inline-block;
  width: 100%;
  height: 50px;
}

tr {
  display: inline-block;
  width: 100%;
  height: 50px;
}

td {
  display: inline-block;
}

.emojiss {
  position: absolute;
  right: 30px;
  bottom: 10px;
}

.emojiss ul {
  background-color: white;
  width: 200px;
}

.emojiss ul li {
  padding: 1px;
}

.head {
  /* overflow: hidden; */
  /* transform:100px; */
  --el-header-height: 80px;
  background-color: rgb(246, 246, 246, 0.6);
}

.head > div {
  padding-top: 10px;
}

.head h1 {
  font-size: 20px;
  padding: 5px;
}

.head .el-input {
  width: 25%;
}

.head > h3 {
  margin-top: 18px;
}

#fridenzz {
  gap: 20px;
  border-radius: 3px;
  backdrop-filter: blur(0px);
  background-color: rgba(0, 0, 0, 0.065);
  box-shadow: rgba(0, 0, 0, 0.3) 2px 8px 8px;
  border: 1px rgba(255, 255, 255, 0.4) solid;
  border-bottom: 1px rgba(40, 40, 40, 0.35) solid;
  border-right: 1px rgba(40, 40, 40, 0.35) solid;
}

.frcontents {
  float: right;
  background: greenyellow !important;
  border-radius: 5px;
}

.cell {
  width: 80%;
  margin: 20px auto;
  background: white;
  border-radius: 10px;
  height: 10%;
  display: flex;
  align-items: center;
  transition: transform 1s;
  transition: width 1s;
}

.cell:hover ~ .cell {
  transform: translate(0px, 10px);
  transform: rotateX(60deg);
  transform: rotateY(-30deg);
  transition: transform 2s;
}

.cell:hover {
  height: 12%;
  width: 90%;
  transform: scale(1, 1.1);
}

.input {
  position: absolute;
  top: -40px;
  right: 100px;
}

.el-row {
  margin-bottom: 20px;
}

.el-row:last-child {
  margin-bottom: 0;
}

.el-col {
  border-radius: 4px;
}

.grid-content {
  border-radius: 4px;
  min-height: 36px;
}
</style>